/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package drools5fusioneval;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseConfiguration;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.conf.EventProcessingOption;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.rule.FactHandle;
import org.drools.runtime.rule.WorkingMemoryEntryPoint;


/**
 *
 * @author jpbarto
 */
public class Drools5FusionEval {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws InterruptedException {
        KnowledgeBaseConfiguration kbconfig = KnowledgeBaseFactory.newKnowledgeBaseConfiguration();
        kbconfig.setOption (EventProcessingOption.STREAM);
        
        KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase(kbconfig);
        
        KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder ();
        kbuilder.add (ResourceFactory.newClassPathResource("drools5fusioneval/testrules.drl"), ResourceType.DRL);
        if (kbuilder.hasErrors()) {
            System.err.println (kbuilder.getErrors().toString());
        }
        kbase.addKnowledgePackages(kbuilder.getKnowledgePackages());
        
        final StatefulKnowledgeSession session = kbase.newStatefulKnowledgeSession();
        WorkingMemoryEntryPoint ep01 = session.getWorkingMemoryEntryPoint("ep01");
        
        new Thread () {
            public void run () {
                session.fireUntilHalt();
            }
        }.start ();

        int eventLimit = 300000;
        
        ProbeCounter pc = new ProbeCounter ();
        FactHandle pch = session.insert(pc);
        long myTotal = 0;
        long startTS = System.nanoTime();
        for (int i = 0; i < eventLimit; i++) {
            ep01.insert (new ProbeEvent (1));
            myTotal += 1;
        }
        long stopTS = System.nanoTime();
        long theirVal = pc.getTotal();
        long durationNS = (stopTS - startTS);
        long durationmS = durationNS / 1000;
        long durationMS = durationmS/1000;
        long durationS = durationMS / 1000;
        System.out.println ("ns / microsec / ms / sec");
        System.out.println (durationNS +" / "+ durationmS +" / "+ durationMS +" / "+ durationS);
        System.out.println (durationmS + " microsec, local sum: "+ myTotal +", rule sum: "+ theirVal +" @ "+ (theirVal/durationS) +" rules per sec");
        
        Thread.sleep (10000);
        System.out.println ("After 10s: "+ pc.getTotal());
    }
}
